
//OpenSCADA file: terror.cpp
/***************************************************************************
 *   Copyright (C) 2003-2014,2020 by Roman Savochenko, <roman@oscada.org>  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License.               *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdarg.h>
#include <stdio.h>

#include "terror.h"

using namespace OSCADA;

//*************************************************
//* TError                                        *
//*************************************************
TError::TError( const char *icat, const char *fmt, ... )
{
    char str[1024];			//!!!!
    va_list argptr;

    va_start(argptr,fmt);
    vsnprintf(str,sizeof(str),fmt,argptr);
    va_end(argptr);

    cod  = NoCode;
    mess = str;
    cat  = icat;
}

TError::TError( int icod, const char *icat, const char *fmt, ... )
{
    char str[1024];			//!!!!
    va_list argptr;

    va_start(argptr, fmt);
    vsnprintf(str,sizeof(str),fmt,argptr);
    va_end(argptr);

    cod  = icod;
    mess = str;
    cat  = icat;
}
